# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
import io
import re  # noqa: F401
import warnings
from datetime import datetime
from typing import Optional

from pydantic import conint
from pydantic import StrictStr
from pydantic import validate_arguments
from pydantic import ValidationError

from superwise_api.client.api_client import ApiClient
from superwise_api.client.api_response import ApiResponse
from superwise_api.client.exceptions import ApiTypeError
from superwise_api.client.exceptions import ApiValueError
from superwise_api.client.models.page_source_response import PageSourceResponse
from superwise_api.client.models.source_create_payload import SourceCreatePayload
from superwise_api.client.models.source_response import SourceResponse
from superwise_api.client.models.source_type import SourceType
from superwise_api.client.models.source_update import SourceUpdate


class SourcesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def create_source(self, source_create_payload: SourceCreatePayload, **kwargs) -> SourceResponse:  # noqa: E501
        """Create Source  # noqa: E501

        Create a new source.  The SourceCreate model is defined by either the SourceCreateGCS, SourceCreateAzure or SourceCreateS3 classes, based on the source type.  Parameters:  - **source_id**: UUID of the source. - **payload**: Instance of SourceCreate model which can be any one of the following based on source type:    - **SourceCreateGCS**         - **type**: Literal, Source Type GCS.         - **params**: SourceGCSParams object or None. Parameters for GCS source.         - **credentials**: GCPCredentials object or None. Credentials for GCS source.         - Validation is applied on the `credentials` field based on the hosting type.    - **SourceCreateAzure**         - **type**: Literal, Source type AZURE_BLOB_STORAGE.         - **params**: SourceAzureParams object. Parameters for Azure source.         - **credentials**: AzureCredentials object. Credentials for Azure source.    - **SourceCreateS3**         - **type**: Literal, Source type S3.         - **params**: SourceS3Params object. Parameters for S3 source.         - **credentials**: AWSCredentials object. Credentials for AWS source.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_source(source_create_payload, async_req=True)
        >>> result = thread.get()

        :param source_create_payload: (required)
        :type source_create_payload: SourceCreatePayload
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: SourceResponse
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the create_source_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.create_source_with_http_info(source_create_payload, **kwargs)  # noqa: E501

    @validate_arguments
    def create_source_with_http_info(
        self, source_create_payload: SourceCreatePayload, **kwargs
    ) -> ApiResponse:  # noqa: E501
        """Create Source  # noqa: E501

        Create a new source.  The SourceCreate model is defined by either the SourceCreateGCS, SourceCreateAzure or SourceCreateS3 classes, based on the source type.  Parameters:  - **source_id**: UUID of the source. - **payload**: Instance of SourceCreate model which can be any one of the following based on source type:    - **SourceCreateGCS**         - **type**: Literal, Source Type GCS.         - **params**: SourceGCSParams object or None. Parameters for GCS source.         - **credentials**: GCPCredentials object or None. Credentials for GCS source.         - Validation is applied on the `credentials` field based on the hosting type.    - **SourceCreateAzure**         - **type**: Literal, Source type AZURE_BLOB_STORAGE.         - **params**: SourceAzureParams object. Parameters for Azure source.         - **credentials**: AzureCredentials object. Credentials for Azure source.    - **SourceCreateS3**         - **type**: Literal, Source type S3.         - **params**: SourceS3Params object. Parameters for S3 source.         - **credentials**: AWSCredentials object. Credentials for AWS source.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_source_with_http_info(source_create_payload, async_req=True)
        >>> result = thread.get()

        :param source_create_payload: (required)
        :type source_create_payload: SourceCreatePayload
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(SourceResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = ["source_create_payload"]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method create_source" % _key)
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params["source_create_payload"] is not None:
            _body_params = _params["source_create_payload"]

        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get(
            "_content_type", self.api_client.select_header_content_type(["application/json"])
        )
        if _content_types_list:
            _header_params["Content-Type"] = _content_types_list

        # authentication setting
        _auth_settings = ["implicit"]  # noqa: E501

        _response_types_map = {
            "201": "SourceResponse",
            "404": None,
            "422": "HTTPValidationError",
            "500": None,
        }

        return self.api_client.call_api(
            "/v1/sources",
            "POST",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )

    @validate_arguments
    def delete_source(self, source_id: StrictStr, **kwargs) -> None:  # noqa: E501
        """Delete Source  # noqa: E501

        Delete a specific source.  - **source_id**: UUID of the source  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_source(source_id, async_req=True)
        >>> result = thread.get()

        :param source_id: (required)
        :type source_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the delete_source_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.delete_source_with_http_info(source_id, **kwargs)  # noqa: E501

    @validate_arguments
    def delete_source_with_http_info(self, source_id: StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Delete Source  # noqa: E501

        Delete a specific source.  - **source_id**: UUID of the source  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_source_with_http_info(source_id, async_req=True)
        >>> result = thread.get()

        :param source_id: (required)
        :type source_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        _params = locals()

        _all_params = ["source_id"]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method delete_source" % _key)
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params["source_id"] is not None:
            _path_params["source_id"] = _params["source_id"]

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])  # noqa: E501

        # authentication setting
        _auth_settings = ["implicit"]  # noqa: E501

        _response_types_map = {}

        return self.api_client.call_api(
            "/v1/sources/{source_id}",
            "DELETE",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )

    @validate_arguments
    def get_source(self, source_id: StrictStr, **kwargs) -> SourceResponse:  # noqa: E501
        """Get Source  # noqa: E501

        Retrieve a Source based on the given source_id.  - **source_id**: UUID of the source  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_source(source_id, async_req=True)
        >>> result = thread.get()

        :param source_id: (required)
        :type source_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: SourceResponse
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the get_source_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_source_with_http_info(source_id, **kwargs)  # noqa: E501

    @validate_arguments
    def get_source_with_http_info(self, source_id: StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Get Source  # noqa: E501

        Retrieve a Source based on the given source_id.  - **source_id**: UUID of the source  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_source_with_http_info(source_id, async_req=True)
        >>> result = thread.get()

        :param source_id: (required)
        :type source_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(SourceResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = ["source_id"]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method get_source" % _key)
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params["source_id"] is not None:
            _path_params["source_id"] = _params["source_id"]

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])  # noqa: E501

        # authentication setting
        _auth_settings = ["implicit"]  # noqa: E501

        _response_types_map = {
            "200": "SourceResponse",
            "404": None,
            "422": "HTTPValidationError",
            "500": None,
        }

        return self.api_client.call_api(
            "/v1/sources/{source_id}",
            "GET",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )

    @validate_arguments
    def get_sources(
        self,
        name: Optional[StrictStr] = None,
        created_by: Optional[StrictStr] = None,
        created_at: Optional[datetime] = None,
        updated_at: Optional[datetime] = None,
        type: Optional[SourceType] = None,
        page: Optional[conint(strict=True, ge=1)] = None,
        size: Optional[conint(strict=True, le=100, ge=1)] = None,
        **kwargs
    ) -> PageSourceResponse:  # noqa: E501
        """Get Sources  # noqa: E501

        Retrieve all sources based on the provided filters.  - **name**: Name of the source - **created_by**: Creator of the source - **created_at**: When the source was created - **updated_at**: When the source was last updated - **type**: Type of the source  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_sources(name, created_by, created_at, updated_at, type, page, size, async_req=True)
        >>> result = thread.get()

        :param name:
        :type name: str
        :param created_by:
        :type created_by: str
        :param created_at:
        :type created_at: datetime
        :param updated_at:
        :type updated_at: datetime
        :param type:
        :type type: SourceType
        :param page:
        :type page: int
        :param size:
        :type size: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PageSourceResponse
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the get_sources_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_sources_with_http_info(
            name, created_by, created_at, updated_at, type, page, size, **kwargs
        )  # noqa: E501

    @validate_arguments
    def get_sources_with_http_info(
        self,
        name: Optional[StrictStr] = None,
        created_by: Optional[StrictStr] = None,
        created_at: Optional[datetime] = None,
        updated_at: Optional[datetime] = None,
        type: Optional[SourceType] = None,
        page: Optional[conint(strict=True, ge=1)] = None,
        size: Optional[conint(strict=True, le=100, ge=1)] = None,
        **kwargs
    ) -> ApiResponse:  # noqa: E501
        """Get Sources  # noqa: E501

        Retrieve all sources based on the provided filters.  - **name**: Name of the source - **created_by**: Creator of the source - **created_at**: When the source was created - **updated_at**: When the source was last updated - **type**: Type of the source  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_sources_with_http_info(name, created_by, created_at, updated_at, type, page, size, async_req=True)
        >>> result = thread.get()

        :param name:
        :type name: str
        :param created_by:
        :type created_by: str
        :param created_at:
        :type created_at: datetime
        :param updated_at:
        :type updated_at: datetime
        :param type:
        :type type: SourceType
        :param page:
        :type page: int
        :param size:
        :type size: int
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PageSourceResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = ["name", "created_by", "created_at", "updated_at", "type", "page", "size"]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method get_sources" % _key)
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get("name") is not None:  # noqa: E501
            _query_params.append(("name", _params["name"]))

        if _params.get("created_by") is not None:  # noqa: E501
            _query_params.append(("created_by", _params["created_by"]))

        if _params.get("created_at") is not None:  # noqa: E501
            if isinstance(_params["created_at"], datetime):
                _query_params.append(
                    ("created_at", _params["created_at"].strftime(self.api_client.configuration.datetime_format))
                )
            else:
                _query_params.append(("created_at", _params["created_at"]))

        if _params.get("updated_at") is not None:  # noqa: E501
            if isinstance(_params["updated_at"], datetime):
                _query_params.append(
                    ("updated_at", _params["updated_at"].strftime(self.api_client.configuration.datetime_format))
                )
            else:
                _query_params.append(("updated_at", _params["updated_at"]))

        if _params.get("type") is not None:  # noqa: E501
            _query_params.append(("type", _params["type"].value))

        if _params.get("page") is not None:  # noqa: E501
            _query_params.append(("page", _params["page"]))

        if _params.get("size") is not None:  # noqa: E501
            _query_params.append(("size", _params["size"]))

        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])  # noqa: E501

        # authentication setting
        _auth_settings = ["implicit"]  # noqa: E501

        _response_types_map = {
            "200": "PageSourceResponse",
            "422": "HTTPValidationError",
            "500": None,
        }

        return self.api_client.call_api(
            "/v1/sources",
            "GET",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )

    @validate_arguments
    def update_source(
        self, source_id: StrictStr, source_update: SourceUpdate, **kwargs
    ) -> SourceResponse:  # noqa: E501
        """Update Source  # noqa: E501

        Update an existing source.  The SourceUpdate Model is defined by the SourceUpdateGCS or SourceUpdateS3 class, based on the source type.  Parameters:  - **source_id**: UUID of the source to update.  - **payload**: Instance of SourceUpdate model which can be any one of the following based on source type:    - **SourceUpdateGCS**         - **type**: Literal, Source Type GCS.         - **params**: SourceGCSParams object or None. Parameters for GCS source.         - **credentials**: GCPCredentials object or None. Credentials for GCS source.    - **SourceUpdateS3**         - **type**: Literal, Source type S3.         - **params**: SourceS3Params object or None. Parameters for S3 source.         - **credentials**: AWSCredentials object or None. Credentials for AWS source.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_source(source_id, source_update, async_req=True)
        >>> result = thread.get()

        :param source_id: (required)
        :type source_id: str
        :param source_update: (required)
        :type source_update: SourceUpdate
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: SourceResponse
        """
        kwargs["_return_http_data_only"] = True
        if "_preload_content" in kwargs:
            message = "Error! Please call the update_source_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.update_source_with_http_info(source_id, source_update, **kwargs)  # noqa: E501

    @validate_arguments
    def update_source_with_http_info(
        self, source_id: StrictStr, source_update: SourceUpdate, **kwargs
    ) -> ApiResponse:  # noqa: E501
        """Update Source  # noqa: E501

        Update an existing source.  The SourceUpdate Model is defined by the SourceUpdateGCS or SourceUpdateS3 class, based on the source type.  Parameters:  - **source_id**: UUID of the source to update.  - **payload**: Instance of SourceUpdate model which can be any one of the following based on source type:    - **SourceUpdateGCS**         - **type**: Literal, Source Type GCS.         - **params**: SourceGCSParams object or None. Parameters for GCS source.         - **credentials**: GCPCredentials object or None. Credentials for GCS source.    - **SourceUpdateS3**         - **type**: Literal, Source type S3.         - **params**: SourceS3Params object or None. Parameters for S3 source.         - **credentials**: AWSCredentials object or None. Credentials for AWS source.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_source_with_http_info(source_id, source_update, async_req=True)
        >>> result = thread.get()

        :param source_id: (required)
        :type source_id: str
        :param source_update: (required)
        :type source_update: SourceUpdate
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(SourceResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = ["source_id", "source_update"]
        _all_params.extend(
            [
                "async_req",
                "_return_http_data_only",
                "_preload_content",
                "_request_timeout",
                "_request_auth",
                "_content_type",
                "_headers",
            ]
        )

        # validate the arguments
        for _key, _val in _params["kwargs"].items():
            if _key not in _all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method update_source" % _key)
            _params[_key] = _val
        del _params["kwargs"]

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params["source_id"] is not None:
            _path_params["source_id"] = _params["source_id"]

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get("_headers", {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params["source_update"] is not None:
            _body_params = _params["source_update"]

        # set the HTTP header `Accept`
        _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get(
            "_content_type", self.api_client.select_header_content_type(["application/json"])
        )
        if _content_types_list:
            _header_params["Content-Type"] = _content_types_list

        # authentication setting
        _auth_settings = ["implicit"]  # noqa: E501

        _response_types_map = {
            "200": "SourceResponse",
            "404": None,
            "422": "HTTPValidationError",
            "500": None,
        }

        return self.api_client.call_api(
            "/v1/sources/{source_id}",
            "PATCH",
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get("async_req"),
            _return_http_data_only=_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=_params.get("_preload_content", True),
            _request_timeout=_params.get("_request_timeout"),
            collection_formats=_collection_formats,
            _request_auth=_params.get("_request_auth"),
        )
