# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr
from pydantic import validator


class AzureCredentialsRequest(BaseModel):
    """
    AzureCredentialsRequest
    """

    credentials_type: Optional[StrictStr] = "AZURE"
    tenant_id: StrictStr = Field(...)
    client_id: StrictStr = Field(...)
    client_secret: StrictStr = Field(...)
    __properties = ["credentials_type", "tenant_id", "client_id", "client_secret"]

    @validator("credentials_type")
    def credentials_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("AZURE"):
            raise ValueError("must be one of enum values ('AZURE')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AzureCredentialsRequest:
        """Create an instance of AzureCredentialsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AzureCredentialsRequest:
        """Create an instance of AzureCredentialsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AzureCredentialsRequest.parse_obj(obj)

        _obj = AzureCredentialsRequest.parse_obj(
            {
                "credentials_type": obj.get("credentials_type") if obj.get("credentials_type") is not None else "AZURE",
                "tenant_id": obj.get("tenant_id"),
                "client_id": obj.get("client_id"),
                "client_secret": obj.get("client_secret"),
            }
        )
        return _obj
