# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import List
from typing import Optional
from typing import Union

from pydantic import BaseModel
from pydantic import conlist
from pydantic import StrictBool
from pydantic import StrictFloat
from pydantic import StrictInt
from pydantic import StrictStr

from superwise_api.client.models.alert_on_status_direction import AlertOnStatusDirection
from superwise_api.client.models.policy_query import PolicyQuery
from superwise_api.client.models.time_range_unit import TimeRangeUnit


class PolicyUpdate(BaseModel):
    """
    PolicyUpdate
    """

    name: Optional[StrictStr] = None
    query: Optional[PolicyQuery] = None
    cron_expression: Optional[StrictStr] = None
    condition_above_value: Optional[Union[StrictFloat, StrictInt]] = None
    condition_below_value: Optional[Union[StrictFloat, StrictInt]] = None
    destination_ids: Optional[conlist(StrictStr)] = None
    alert_on_status: Optional[AlertOnStatusDirection] = None
    alert_on_policy_level: Optional[StrictBool] = None
    dataset_id: Optional[StrictStr] = None
    time_range_field: Optional[StrictStr] = None
    time_range_unit: Optional[TimeRangeUnit] = None
    time_range_value: Optional[StrictInt] = None
    __properties = [
        "name",
        "query",
        "cron_expression",
        "condition_above_value",
        "condition_below_value",
        "destination_ids",
        "alert_on_status",
        "alert_on_policy_level",
        "dataset_id",
        "time_range_field",
        "time_range_unit",
        "time_range_value",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PolicyUpdate:
        """Create an instance of PolicyUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of query
        if self.query:
            _dict["query"] = self.query.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PolicyUpdate:
        """Create an instance of PolicyUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PolicyUpdate.parse_obj(obj)

        _obj = PolicyUpdate.parse_obj(
            {
                "name": obj.get("name"),
                "query": PolicyQuery.from_dict(obj.get("query")) if obj.get("query") is not None else None,
                "cron_expression": obj.get("cron_expression"),
                "condition_above_value": obj.get("condition_above_value"),
                "condition_below_value": obj.get("condition_below_value"),
                "destination_ids": obj.get("destination_ids"),
                "alert_on_status": obj.get("alert_on_status"),
                "alert_on_policy_level": obj.get("alert_on_policy_level"),
                "dataset_id": obj.get("dataset_id"),
                "time_range_field": obj.get("time_range_field"),
                "time_range_unit": obj.get("time_range_unit"),
                "time_range_value": obj.get("time_range_value"),
            }
        )
        return _obj
