# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from inspect import getfullargspec
from typing import Any
from typing import List
from typing import Optional
from typing import TYPE_CHECKING
from typing import Union

from pydantic import BaseModel
from pydantic import Field
from pydantic import StrictStr
from pydantic import ValidationError
from pydantic import validator

from superwise_api.client.models.source_get_azure import SourceGetAzure
from superwise_api.client.models.source_get_gcs import SourceGetGCS
from superwise_api.client.models.source_get_s3 import SourceGetS3

SOURCE_ONE_OF_SCHEMAS = ["SourceGetAzure", "SourceGetGCS", "SourceGetS3"]


class Source(BaseModel):
    """
    Source
    """

    # data type: SourceGetS3
    oneof_schema_1_validator: Optional[SourceGetS3] = None
    # data type: SourceGetAzure
    oneof_schema_2_validator: Optional[SourceGetAzure] = None
    # data type: SourceGetGCS
    oneof_schema_3_validator: Optional[SourceGetGCS] = None
    if TYPE_CHECKING:
        actual_instance: Union[SourceGetAzure, SourceGetGCS, SourceGetS3]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(SOURCE_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = Source.construct()
        error_messages = []
        match = 0
        # validate data type: SourceGetS3
        if not isinstance(v, SourceGetS3):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SourceGetS3`")
        else:
            match += 1
        # validate data type: SourceGetAzure
        if not isinstance(v, SourceGetAzure):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SourceGetAzure`")
        else:
            match += 1
        # validate data type: SourceGetGCS
        if not isinstance(v, SourceGetGCS):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SourceGetGCS`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in Source with oneOf schemas: SourceGetAzure, SourceGetGCS, SourceGetS3. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in Source with oneOf schemas: SourceGetAzure, SourceGetGCS, SourceGetS3. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Source:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Source:
        """Returns the object represented by the json string"""
        instance = Source.construct()
        error_messages = []
        match = 0

        # deserialize data into SourceGetS3
        try:
            instance.actual_instance = SourceGetS3.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SourceGetAzure
        try:
            instance.actual_instance = SourceGetAzure.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SourceGetGCS
        try:
            instance.actual_instance = SourceGetGCS.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into Source with oneOf schemas: SourceGetAzure, SourceGetGCS, SourceGetS3. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into Source with oneOf schemas: SourceGetAzure, SourceGetGCS, SourceGetS3. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())
