# coding: utf-8
"""
    Superwise Main Entities

    API reference

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel
from pydantic import StrictStr
from pydantic import validator

from superwise_api.client.models.aws_credentials_request import AWSCredentialsRequest
from superwise_api.client.models.source_s3_params import SourceS3Params


class SourceUpdateS3(BaseModel):
    """
    SourceUpdateS3
    """

    name: Optional[StrictStr] = None
    credentials: Optional[AWSCredentialsRequest] = None
    params: Optional[SourceS3Params] = None
    type: Optional[StrictStr] = "S3"
    __properties = ["name", "credentials", "params", "type"]

    @validator("type")
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("S3"):
            raise ValueError("must be one of enum values ('S3')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SourceUpdateS3:
        """Create an instance of SourceUpdateS3 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of credentials
        if self.credentials:
            _dict["credentials"] = self.credentials.to_dict()
        # override the default output from pydantic by calling `to_dict()` of params
        if self.params:
            _dict["params"] = self.params.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SourceUpdateS3:
        """Create an instance of SourceUpdateS3 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SourceUpdateS3.parse_obj(obj)

        _obj = SourceUpdateS3.parse_obj(
            {
                "name": obj.get("name"),
                "credentials": AWSCredentialsRequest.from_dict(obj.get("credentials"))
                if obj.get("credentials") is not None
                else None,
                "params": SourceS3Params.from_dict(obj.get("params")) if obj.get("params") is not None else None,
                "type": obj.get("type") if obj.get("type") is not None else "S3",
            }
        )
        return _obj
